CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  rxpin = 31 ' Receive on I/O pin 1 <- black from master black txpin p1 
  txpin = 30 ' Transmit on I/O pin 0 -> red to master red rxpin p0
  ServoCh1 = 16  'Pan                            
  ServoCh2 = 20  'Tilt
  ServoCh3 = 0   'Steering servo
  MotorChA = 7
  
   
VAR
  LONG SerStack[200]
  LONG Drivestack[200]
  LONG txVal_1, txVal_2, txVal_3, txVal_4 ' transmit
  LONG rxVal_1, rxVal_2, rxVal_3, rxVal_4 ' receive from master and PST
  LONG rxVal
  LONG rxHeight 
  LONG rxWidth 
  LONG rxTurretL 
  LONG rxTurretR
  LONG rxSteerL
  LONG rxSteerR
  LONG rxDriveF
  LONG rxDriveR
  LONG Direction

OBJ

  serial : "FullDuplexSerial"   ' "Extended_FDSerial" '' 
  f : "Float32Full" 
  SERVO : "Servo32v7.spin"
  
PUB Main | DutyCycle, temp,GetData' new stuff DutyCycle

   
  SERVO.Start
  SERVO.Ramp
  InitESC
  serial.start(rxpin,txpin,%0000, 38400)          '- rxpin,txpin,mode,Baud
  Cognew(Drive,@DriveStack)
  Cognew(GetSer,@SerStack)
  
     
PUB InitESC
          
    SERVO.Set(MotorChA,1400)                  'Move Servo to Center
    repeat 50000                               'Initialize ESC's

PUB GetSer

    repeat
      rxHeight := SerCog
      rxWidth := SerCog
      rxTurretR := SerCog 
      rxTurretL := SerCog
      rxSteerR := SerCog      
      rxSteerL := SerCog
      rxDriveR := SerCog
      rxDriveF := SerCog

      serial.str(string("rxHeight=")) 
      serial.dec(rxHeight) 
      serial.tx(13) 
       
      serial.str(string("rxWidth=")) 
      serial.dec(rxWidth) 
      serial.tx(13) 
       
      serial.str(string("rxTurretR=")) 
      serial.dec(rxTurretR) 
      serial.tx(13)
       
      serial.str(string("rxTurretL=")) 
      serial.dec(rxTurretL) 
      serial.tx(13) 
       
      serial.str(string("rxSteerR=")) 
      serial.dec(rxSteerR) 
      serial.tx(13)
       
      serial.str(string("rxSteerL=")) 
      serial.dec(rxSteerL) 
      serial.tx(13)
       
      serial.str(string("rxDriveR=")) 
      serial.dec(rxDriveR) 
      serial.tx(13)
  
      serial.str(string("rxDriveF=")) 
      serial.dec(rxDriveF) 
      serial.tx(13)

PUB Drive

    repeat
                   
      IF rxSteerL == 1                              'If value is 1 turn left
        SERVO.SetRamp(ServoCh3,1000,70)
        SERVO.SetRamp(ServoCh1,2000,200)
      IF rxSteerR == 1                              'If value is 1 turn right
        SERVO.SetRamp(ServoCh3,1900,70)
        SERVO.SetRamp(ServoCh1,1000,200)            
      IF rxSteerR == 0 and rxSteerL == 0            'If value is 0 no turn 
        SERVO.SetRamp(ServoCh3,1425,70)
        SERVO.SetRamp(ServoCh1,1400,200)
   
      IF rxDriveR == 1
'        serial.str(string("SUCCESS"))
        Direction := 1425                            'Drive Reverse 
      IF rxDriveF == 1
        Direction := 1365                            'Drive Forward
       IF rxDriveF == 0 and rxDriveR == 0          'Stop Motor channel A 
        Direction := 1400
      SERVO.SetRamp(MotorChA,Direction,300)                                             'Pulsewidth #1400 is 0% duty
                                                 '    "      #1500 is 100% forward
                                                 '    "      #1300 is 100% reverse
PRI SerCog 

    rxVal_1 := serial.rx                        'Get next value from roborealm
    rxVal_2 := serial.rx 
    rxVal_3 := serial.rx 
    rxVal_4 := serial.rx 
    
    rxVal := rxVal_1 | (rxVal_2<<8) | (rxVal_3<<16) | (rxVal_4<<24)
    
    RETURN rxVal
{
\\[IMAGE_HEIGHT]\\[IMAGE_WIDTH]\\[NV_TURRET_LEFT]\\[NV_RIGHT]\\[NV_LEFT]\\[NV_BACKWARDS]\\[NV_FORWARD]
}                 